# To change this template, choose Tools | Templates
# and open the template in the editor.
Sketchup::require 'sketchup'
Sketchup::require 'city_g_m_l_layer_maker.rb'

toolbar = UI::Toolbar.new "Erstelle CityGML Building Layer"
toolbarbridge = UI::Toolbar.new "Erstelle CityGML Bridge Layer"
toolbarrest = UI::Toolbar.new "Erstelle div. CityGML Layer"
layermaker = CityGMLLayerMaker.new()


if(not $toolsBuildingLoaded)
          groundSolid = UI::Command.new("GroundSurface") {
           layermaker.createlayerboundary("GROUNDS", true, "BUILDING", false)
         }
         groundSolid.small_icon = "Images/building_ground16.png"
         groundSolid.large_icon = "Images/building_ground24.png"
         groundSolid.tooltip = "Erstelle einen GroundSurface Layer, der auch Teil der Solid Geometrie ist"
         groundSolid.status_bar_text = "Erstelle eine GroundSurface"
         groundSolid.menu_text = "Erstelle einen GroundSurface"
         toolbar = toolbar.add_item groundSolid
          wallSolid = UI::Command.new("WallSurface") {
               layermaker.createlayerboundary("WALLS", true, "BUILDING", false)
         }
         wallSolid.small_icon = "Images/building_wall16.png"
         wallSolid.large_icon = "Images/building_wall24.png"
         wallSolid.tooltip = "Erstelle einen WallSurface Layer, der auch Teil der Solid Geometrie ist"
         wallSolid.status_bar_text = "Erstelle eine WallSurface"
         wallSolid.menu_text = "Erstelle eine WallSurface"
         toolbar = toolbar.add_item wallSolid
         roofSolid = UI::Command.new("RoofSurface") {
               layermaker.createlayerboundary("ROOFS", true, "BUILDING", false)
         }
         roofSolid.small_icon = "Images/building_roof16.png"
         roofSolid.large_icon = "Images/building_roof24.png"
         roofSolid.tooltip = "Erstelle einen RoofSurface Layer, der auch Teil der Solid Geometrie ist"
         roofSolid.status_bar_text = "Erstelle eine RoofSurface"
         roofSolid.menu_text = "Erstelle eine RoofSurface"
         toolbar = toolbar.add_item roofSolid
         closureSolid = UI::Command.new("ClosureSurface ") {
              layermaker.createlayerboundary("CLOSURES", true, "BUILDING", false)
         }
         closureSolid.small_icon = "Images/building_closure16.png"
         closureSolid.large_icon = "Images/building_closure24.png"
         closureSolid.tooltip = "Erstelle einen ClosureSurface Layer, der auch Teil der Solid Geometrie ist"
         closureSolid.status_bar_text = "Erstelle eine ClosureSurface"
         closureSolid.menu_text = "Erstelle eine ClosureSurface"
         toolbar = toolbar.add_item closureSolid
         outerFloorSolid = UI::Command.new("OuterFloorSurface") {
               layermaker.createlayerboundary("OUTERFLOORS", true, "BUILDING", false)
         }
         outerFloorSolid.small_icon = "Images/building_outerfloor16.png"
         outerFloorSolid.large_icon = "Images/building_outerfloor24.png"
         outerFloorSolid.tooltip = "Erstelle einen OuterFloorSurface Layer, der auch Teil der Solid Geometrie ist"
         outerFloorSolid.status_bar_text = "Erstelle eine OuterFloorSurface"
         outerFloorSolid.menu_text = "Erstelle eine OuterFloorSurface"
         toolbar = toolbar.add_item outerFloorSolid
         outerCeilingSolid = UI::Command.new("OuterCeilingSurface ") {
               layermaker.createlayerboundary("OUTERCEILINGS", true, "BUILDING", false)
         }
         outerCeilingSolid.small_icon = "Images/building_outerceiling16.png"
         outerCeilingSolid.large_icon = "Images/building_outerceiling24.png"
         outerCeilingSolid.tooltip = "Erstelle einen OuterCeilingSurface Layer, der auch Teil der Solid Geometrie ist"
         outerCeilingSolid.status_bar_text = "Erstelle eine OuterCeilingSurface"
         outerCeilingSolid.menu_text = "Erstelle eine OuterCeilingSurface"
         toolbar = toolbar.add_item outerCeilingSolid

        roofNoSolid = UI::Command.new("RoofSurface - no Solid ") {
               layermaker.createlayerboundary("ROOFS", false, "BUILDING", false)
         }
         roofNoSolid.small_icon = "Images/building_roofNoSolid16.png"
         roofNoSolid.large_icon = "Images/building_roofNoSolid24.png"
         roofNoSolid.tooltip = "Erstelle einen RoofSurface Layer, der NICHT Teil der Solid Geometrie ist"
         roofNoSolid.status_bar_text = "Erstelle eine RoofSurface"
         roofNoSolid.menu_text = "Erstelle eine RoofSurface"
         toolbar = toolbar.add_item roofNoSolid


        uniqueWall = UI::Command.new("Eindeutige WallSurface") {
              layermaker.createlayerboundary("WALL", false, "BUILDING", true)
         }
         uniqueWall.small_icon = "Images/building_wallWindow16.png"
         uniqueWall.large_icon = "Images/building_wallWindow24.png"
         uniqueWall.tooltip = "Erstelle einen WallSurface Layer, der Fenster und Tueren enthalten kann"
         uniqueWall.status_bar_text = "Erstelle eine WallSurface"
         uniqueWall.menu_text = "Erstelle eine WallSurface"
         toolbar = toolbar.add_item uniqueWall

        uniqueRoof = UI::Command.new("Eindeutige RoofSurface") {
              layermaker.createlayerboundary("ROOF", false, "BUILDING", true)
         }
         uniqueRoof.small_icon = "Images/building_roofWindow16.png"
         uniqueRoof.large_icon = "Images/building_roofWindow24.png"
         uniqueRoof.tooltip = "Erstelle einen RoofSurface Layer, der Fenster und Tueren enthalten kann"
         uniqueRoof.status_bar_text = "Erstelle eine RoofSurface"
         uniqueRoof.menu_text = "Erstelle eine RoofSurface"
         toolbar = toolbar.add_item uniqueRoof

         door = UI::Command.new("Door") {
           layermaker.createlayeropening("DOORS")
         }
         door.small_icon = "Images/building_door16.png"
         door.large_icon = "Images/building_door24.png"
         door.tooltip = "Erstelle einen Door Layer"
         door.status_bar_text = "Door"
         door.menu_text = "Door"
         toolbar = toolbar.add_item door
         window = UI::Command.new("Window") {
               layermaker.createlayeropening("WINDOWS")
         }
         window.small_icon = "Images/building_window16.png"
         window.large_icon = "Images/building_window24.png"
         window.tooltip = "Erstelle einen Window Layer"
         window.status_bar_text = "Window"
         window.menu_text = "Window"
         toolbar = toolbar.add_item window

         buiInst = UI::Command.new("BuildingInstallation ") {
           layermaker.createlayerinstallation("BUIINST")
         }
         buiInst.small_icon = "Images/building_buiInst16.png"
         buiInst.large_icon = "Images/building_buiInst24.png"
         buiInst.tooltip = "Erstelle einen BuildingInstallation Layer"
         buiInst.status_bar_text = "BuildingInstallation"
         buiInst.menu_text = "BuildingInstallation"
         toolbar = toolbar.add_item buiInst
         $toolsBuildingLoaded = true
end

if(not $toolsBridgeLoaded)
          gs = UI::Command.new("Ground") {
           layermaker.createlayerboundary("GROUNDS", false, "BRIDGE", false)
         }
         gs.small_icon = "Images/bridge_ground16.png"
         gs.large_icon = "Images/bridge_ground24.png"
         gs.tooltip = "Erstelle einen GroundSurface Layer"
         gs.status_bar_text = "Erstelle eine GroundSurface"
         gs.menu_text = "Erstelle einen GroundSurface"
         toolbarbridge = toolbarbridge.add_item gs

          ws = UI::Command.new("WallSurface") {
               layermaker.createlayerboundary("WALLS", false, "BRIDGE", false)
         }
         ws.small_icon = "Images/bridge_wall16.png"
         ws.large_icon = "Images/bridge_wall24.png"
         ws.tooltip = "Erstelle einen WallSurface Layer"
         ws.status_bar_text = "Erstelle eine WallSurface"
         ws.menu_text = "Erstelle eine WallSurface"
         toolbarbridge = toolbarbridge.add_item ws
         rs = UI::Command.new("RoofSurface") {
               layermaker.createlayerboundary("ROOFS", false, "BRIDGE", false)
         }
         rs.small_icon = "Images/bridge_roof16.png"
         rs.large_icon = "Images/bridge_roof24.png"
         rs.tooltip = "Erstelle einen RoofSurface Layer"
         rs.status_bar_text = "Erstelle eine RoofSurface"
         rs.menu_text = "Erstelle eine RoofSurface"
         toolbarbridge = toolbarbridge.add_item rs
         cs = UI::Command.new("ClosureSurface ") {
              layermaker.createlayerboundary("CLOSURES", false, "BRIDGE", false)
         }
         cs.small_icon = "Images/bridge_closure16.png"
         cs.large_icon = "Images/bridge_closure24.png"
         cs.tooltip = "Erstelle einen ClosureSurface Layer"
         cs.status_bar_text = "Erstelle eine ClosureSurface"
         cs.menu_text = "Erstelle eine ClosureSurface"
         toolbarbridge = toolbarbridge.add_item cs
         fs = UI::Command.new("OuterFloorSurface") {
               layermaker.createlayerboundary("OUTERFLOORS", false, "BRIDGE", false)
         }
         fs.small_icon = "Images/bridge_outerFloor16.png"
         fs.large_icon = "Images/bridge_outerFloor24.png"
         fs.tooltip = "Erstelle einen OuterFloorSurface Layer"
         fs.status_bar_text = "Erstelle eine OuterFloorSurface"
         fs.menu_text = "Erstelle eine OuterFloorSurface"
         toolbarbridge = toolbarbridge.add_item fs
         ocs = UI::Command.new("OuterCeilingSurface ") {
               layermaker.createlayerboundary("OUTERCEILINGS", false, "BRIDGE", false)
         }
         ocs.small_icon = "Images/bridge_outerCeiling16.png"
         ocs.large_icon = "Images/bridge_outerCeiling24.png"
         ocs.tooltip = "Erstelle einen OuterCeilingSurface Layer"
         ocs.status_bar_text = "Erstelle eine OuterCeilingSurface"
         ocs.menu_text = "Erstelle eine OuterCeilingSurface"
         toolbarbridge = toolbarbridge.add_item ocs

        rns = UI::Command.new("BridgeConstructionElement") {
               layermaker.createlayerconstr()
         }
         rns.small_icon = "Images/bridge_bridgeConstrElement16.png"
         rns.large_icon = "Images/bridge_bridgeConstrElement24.png"
         rns.tooltip = "Erstelle einen BridgeConstructionElement Layer"
         rns.status_bar_text = "Erstelle ein BridgeConstructionElement"
         rns.menu_text = "Erstelle ein BridgeConstructionElement"
         toolbarbridge = toolbarbridge.add_item rns


        wns = UI::Command.new("Eindeutige WallSurface") {
              layermaker.createlayerboundary("WALL", false, "BRIDGE", true)
         }
         wns.small_icon = "Images/bridge_WallWindow16.png"
         wns.large_icon = "Images/bridge_WallWindow24.png"
         wns.tooltip = "Erstelle einen WallSurface Layer, der Fenster und Tueren enthalten kann"
         wns.status_bar_text = "Erstelle eine WallSurface"
         wns.menu_text = "Erstelle eine WallSurface"
         toolbarbridge = toolbarbridge.add_item wns

        ur = UI::Command.new("Eindeutige RoofSurface") {
              layermaker.createlayerboundary("ROOF", false, "BRIDGE", true)
         }
         ur.small_icon = "Images/bridge_roofWindow16.png"
         ur.large_icon = "Images/bridge_roofWindow24.png"
         ur.tooltip = "Erstelle einen RoofSurface Layer, der Fenster und Tueren enthalten kann"
         ur.status_bar_text = "Erstelle eine RoofSurface"
         ur.menu_text = "Erstelle eine RoofSurface"
         toolbarbridge = toolbarbridge.add_item ur
         d = UI::Command.new("Door") {
           layermaker.createlayeropening("DOORS")
         }
         d.small_icon = "Images/bridge_door16.png"
         d.large_icon = "Images/bridge_door24.png"
         d.tooltip = "Erstelle einen Door Layer"
         d.status_bar_text = "Door"
         d.menu_text = "Door"
         toolbarbridge = toolbarbridge.add_item d
         w = UI::Command.new("Window") {
               layermaker.createlayeropening("WINDOWS")
         }
         w.small_icon = "Images/bridge_Window16.png"
         w.large_icon = "Images/bridge_Window24.png"
         w.tooltip = "Erstelle einen Window Layer"
         w.status_bar_text = "Window"
         w.menu_text = "Window"
         toolbarbridge = toolbarbridge.add_item w

         bri = UI::Command.new("BridgeInstallation ") {
           layermaker.createlayerinstallation("BRIDGEINSTALLATION")
         }
         bri.small_icon = "Images/bridge_bridgeInst16.png"
         bri.large_icon = "Images/bridge_bridgeInst24.png"
         bri.tooltip = "Erstelle einen BridgeInstallation Layer"
         bri.status_bar_text = "BridgeInstallation"
         bri.menu_text = "BridgeInstallation"
         toolbarbridge = toolbarbridge.add_item bri
         $toolsBridgeLoaded = true
end

if(not $toolsRestLoaded)
      tin = UI::Command.new("TIN ") {
           layermaker.createtin()
         }
         tin.small_icon = "Images/tin16.png"
         tin.large_icon = "Images/tin24.png"
         tin.tooltip = "Erstelle einen TIN Layer"
         tin.status_bar_text = "TIN"
         tin.menu_text = "TIN"
         toolbarrest = toolbarrest.add_item tin

         gen = UI::Command.new("GenericCityObject") {
           layermaker.createlodobject("GENERICCITYOBJECT")
         }
         gen.small_icon = "Images/generic16.png"
         gen.large_icon = "Images/generic24.png"
         gen.tooltip = "Erstelle einen GenericCityObject Layer"
         gen.status_bar_text = "GenericCityObject"
         gen.menu_text = "GenericCityObject"
         toolbarrest = toolbarrest.add_item gen

         sol = UI::Command.new("SolitaryVegetationObject") {
           layermaker.createlodobject("SOLVEGOBJECT")
         }
         sol.small_icon = "Images/solitayrVeg16.png"
         sol.large_icon = "Images/solitayrVeg24.png"
         sol.tooltip = "Erstelle einen SolitaryVegetationObject Layer"
         sol.status_bar_text = "SolitaryVegetationObject"
         sol.menu_text = "SolitaryVegetationObject"
         toolbarrest = toolbarrest.add_item sol

         pla = UI::Command.new("PlantCover") {
           layermaker.createlodobject("PLANTCOVER")
         }
         pla.small_icon = "Images/plantcover16.png"
         pla.large_icon = "Images/plantcover24.png"
         pla.tooltip = "Erstelle einen PlantCover Layer"
         pla.status_bar_text = "PlantCover"
         pla.menu_text = "PlantCover"
         toolbarrest = toolbarrest.add_item pla

        cf = UI::Command.new("CityFurniture") {
           layermaker.createlodobject("CITYFURNITURE")
         }
         cf.small_icon = "Images/cityfurniture16.png"
         cf.large_icon = "Images/cityfurniture24.png"
         cf.tooltip = "Erstelle einen CityFurniture Layer"
         cf.status_bar_text = "CityFurniture"
         cf.menu_text = "CityFurniture"
         toolbarrest = toolbarrest.add_item cf


         gst = UI::Command.new("Ground") {
           layermaker.createlayerboundary("GROUNDS", false, "TUNNEL", false)
         }
         gst.small_icon = "Images/tunnel_ground16.png"
         gst.large_icon = "Images/tunnel_ground24.png"
         gst.tooltip = "Erstelle einen GroundSurface Layer"
         gst.status_bar_text = "Erstelle eine GroundSurface"
         gst.menu_text = "Erstelle einen GroundSurface"
         toolbarrest = toolbarrest.add_item gst

          wst = UI::Command.new("WallSurface") {
               layermaker.createlayerboundary("WALLS", false, "TUNNEL", false)
         }
         wst.small_icon = "Images/tunnel_wall16.png"
         wst.large_icon = "Images/tunnel_wall24.png"
         wst.tooltip = "Erstelle einen WallSurface Layer"
         wst.status_bar_text = "Erstelle eine WallSurface"
         wst.menu_text = "Erstelle eine WallSurface"
         toolbarrest = toolbarrest.add_item wst
         rst = UI::Command.new("RoofSurface") {
               layermaker.createlayerboundary("ROOFS", false, "TUNNEL", false)
         }
         rst.small_icon = "Images/tunnel_roof16.png"
         rst.large_icon = "Images/tunnel_roof24.png"
         rst.tooltip = "Erstelle einen RoofSurface Layer"
         rst.status_bar_text = "Erstelle eine RoofSurface"
         rst.menu_text = "Erstelle eine RoofSurface"
         toolbarrest = toolbarrest.add_item rst
         cst = UI::Command.new("ClosureSurface ") {
              layermaker.createlayerboundary("CLOSURES", false, "TUNNEL", false)
         }
         cst.small_icon = "Images/tunnelclosure16.png"
         cst.large_icon = "Images/tunnelclosure24.png"
         cst.tooltip = "Erstelle einen ClosureSurface Layer"
         cst.status_bar_text = "Erstelle eine ClosureSurface"
         cst.menu_text = "Erstelle eine ClosureSurface"
         toolbarrest = toolbarrest.add_item cst
         tunst = UI::Command.new("TunnelInstallation") {
           layermaker.createlayerinstallation("TUNNELINSTALLATION")
         }
         tunst.small_icon = "Images/tunnel_tunnelInst16.png"
         tunst.large_icon = "Images/tunnel_tunnelInst24.png"
         tunst.tooltip = "Erstelle einen TunnelInstallation Layer"
         tunst.status_bar_text = "TunnelInstallation"
         tunst.menu_text = "TunnelInstallation"
         toolbarrest = toolbarrest.add_item tunst

    $toolsRestLoaded = true
end
 
 toolbar.show
 toolbarbridge.show
 toolbarrest.show