# To change this template, choose Tools | Templates
# and open the template in the editor.
Sketchup::require 'sketchup.rb'
Sketchup::require 'layergensrc/name_tester.rb'
Sketchup::require 'layergensrc/number_generator.rb'

class CityGMLLayerMaker



  def initialize()

    @numbergenerator = NumberGenerator.new()
    @numbergenerator.updatenumbers(Sketchup.active_model)
    @nametester = NameTester.new

  end


  def createlayeropening(type)
    model = Sketchup.active_model
    selection = model.selection
    if( selection == nil || selection.length == 0)
      UI.messagebox "Bitte mindestens eine Geometrie selektieren" , MB_OK
      return
    end
   newlayername = ""
   selection.each{|entity|
      if(newlayername != "")
        break
      end
      layername = entity.layer.name.upcase
      if(@nametester.isboundary(layername))
        layername.each_line('.') { |substr|
          substr = substr.chomp('.')
          if(@nametester.isboundary(substr))
            if(@nametester.ismultiboundary(substr))
                newlayername = ""
            else
              newlayername = layername
            end
          end
        }
      end
    }
    if(newlayername == "")
      UI.messagebox "Bitte erstellen sie zuerst einen eindeutigen Boundary Layer fuer die Geometrien" , MB_OK
      return
    end
    newlayername = newlayername + "." + type
    layer = model.layers.add newlayername
     selection.each{|entity|
      entity.layer= layer
    }
    model.active_layer = layer

  end


 def createlayerboundary(type, issolid, supertype, isunique)
    model = Sketchup.active_model
    selection = model.selection
    if( selection == nil || selection.length == 0)
      UI.messagebox "Bitte mindestens eine Geometrie selektieren" , MB_OK
      return
    end
    if(isunique)
      @numbergenerator.updatenumbers(Sketchup.active_model)
    end
    newlayername = extractNewLayerName

      #puts "newlayername ist " + newlayername
      #puts "supertype ist " + supertype
    if(newlayername == "" or newlayername.index(supertype) == nil)
      arraystring = "Neuer Layer"
      defaults = ["Neuer Layer"]
      newlayername = ""

      @numbergenerator.updatenumbers(Sketchup.active_model)
      if(@nametester.isbuilding(supertype))
        arraystring = arraystring + @numbergenerator.buildingstring
      elsif(@nametester.isbridge(supertype))
        arraystring = arraystring + @numbergenerator.bridgestring
      elsif(@nametester.istunnel(supertype))
        arraystring = arraystring + @numbergenerator.tunnelstring
      end
      prompts = ["Selektiere Layer "]

      list = [arraystring]
      input = UI.inputbox prompts, defaults, list, "Layer Selektion"
      if(input.to_s.upcase.index("NEUER") != nil)
       if(@nametester.isbuilding(supertype))
         @numbergenerator.biggestSiteNumber = @numbergenerator.biggestSiteNumber + 1
         newlayername = "BUILDING" + @numbergenerator.biggestSiteNumber.to_s
       elsif(@nametester.isbridge(supertype))
        @numbergenerator.biggestSiteNumber = @numbergenerator.biggestSiteNumber + 1
         newlayername = "BRIDGE" + @numbergenerator.biggestSiteNumber.to_s
       elsif(@nametester.istunnel(supertype))
        @numbergenerator.biggestSiteNumber = @numbergenerator.biggestSiteNumber + 1
         newlayername = "TUNNEL" + @numbergenerator.biggestSiteNumber.to_s
      end
      elsif(input.to_s != "false")
        newlayername = input.to_s + "." + @typename
      else
        return
      end
    end

    newlayername = newlayername + "." + type
    if(isunique)
      @numbergenerator.biggestBoundaryNumber  = @numbergenerator.biggestBoundaryNumber + 1
      newlayername = newlayername + (@numbergenerator.biggestBoundaryNumber).to_s
    end
    if(issolid and @nametester.isbuildinginst(newlayername) == false and @nametester.isbridgeinst(newlayername) == false and  @nametester.istunnelinst(newlayername) == false)
       newlayername = newlayername + "." + "SOLID"
    end
    layer = model.layers.add newlayername
     selection.each{|entity|
      entity.layer= layer
    }
    model.active_layer = layer

  end

  def createlayerinstallation(type)
    model = Sketchup.active_model
    selection = model.selection
    if( selection == nil || selection.length == 0)
      UI.messagebox "Bitte mindestens eine Geometrie selektieren" , MB_OK
      return
    end
    newlayername = extractNewLayerName
    if(newlayername == "")
      UI.messagebox "Bitte erstellen sie zuerst ein BasisObjekt (Bridge, Building, Tunnel)" , MB_OK
      return
    end

    if(@nametester.isbuildinginst(newlayername) or @nametester.isbridgeinst(newlayername) or @nametester.istunnelinst(newlayername) )
      newlayername = newlayername
    else
      @numbergenerator.biggestInstallationNumber  = @numbergenerator.biggestInstallationNumber + 1
      newlayername = newlayername + "." + type + (@numbergenerator.biggestInstallationNumber).to_s   
    end

    layer = model.layers.add newlayername
     selection.each{|entity|
      entity.layer= layer
    }
    model.active_layer = layer

  end


  def createlayerconstr()
     model = Sketchup.active_model
    selection = model.selection
    if( selection == nil || selection.length == 0)
      UI.messagebox "Bitte mindestens eine Geometrie selektieren" , MB_OK
      return
    end

   newlayername = ""
   selection.each{|entity|
      if(newlayername != "")
        break
      end
      layername = entity.layer.name.upcase
      if(@nametester.isbridge(layername))
        layername.each_line('.') { |substr|
          substr = substr.chomp('.')
          if(@nametester.isbridge(substr) and not @nametester.isbridgeinst(substr) and not @nametester.isconstr(substr) )
              newlayername = substr + "."
          end
        }
      end
    }
    if(newlayername == "")
      arraystring = "Neuer Layer"
      defaults = ["Neuer Layer"]

      @numbergenerator.updatenumbers(Sketchup.active_model)
      arraystring = arraystring + @numbergenerator.bridgestring

      prompts = ["Selektiere Layer "]
      list = [arraystring]
      input = UI.inputbox prompts, defaults, list, "Layer Selektion"
      if(input.to_s.upcase.index("NEUER") != nil)

        @numbergenerator.biggestSiteNumber = @numbergenerator.biggestSiteNumber + 1
         newlayername = "BRIDGE" + @numbergenerator.biggestSiteNumber.to_s + "."

      elsif(input.to_s != "false")
        newlayername = input.to_s + "."
      else
        return
      end
    end
    newlayername = newlayername + "BRIDGECONSTRUCTIONELEMENT" + @numbergenerator.biggestConstructionNumber.to_s
    @numbergenerator.biggestConstructionNumber = @numbergenerator.biggestConstructionNumber + 1
   layer = model.layers.add newlayername
   selection = model.selection
     selection.each{|entity|
      entity.layer= layer
    }
    model.active_layer = layer


  end

  def createtin()
    model = Sketchup.active_model
    selection = model.selection
     layer = model.layers.add "TIN"
     if(selection != nil)
       selection.each{|entity|
      entity.layer= layer
    }
     end
    model.active_layer = layer
  end

  def createlodobject(type)
    model = Sketchup.active_model
    selection = model.selection
    if( selection == nil || selection.length == 0)
      UI.messagebox "Bitte mindestens eine Geometrie selektieren" , MB_OK
      return
    end
     newlayername = ""
      arraystring = "Neuer Layer"
      defaults = ["Neuer Layer"]

      @numbergenerator.updatenumbers(Sketchup.active_model)
      if(@nametester.iscityf(type))
        arraystring = arraystring + @numbergenerator.cfstring
      elsif(@nametester.isveggie(type))
        arraystring = arraystring + @numbergenerator.solvegstring
      elsif(@nametester.isplantcover(type))
        arraystring = arraystring + @numbergenerator.plantcoverstring
      elsif(@nametester.isgencityobject(type))
        arraystring = arraystring + @numbergenerator.genericstring
      end
      

      prompts = ["Selektiere Layer "]
      list = [arraystring]
      input = UI.inputbox prompts, defaults, list, "Layer Selektion"
      if(input.to_s.upcase.index("NEUER") != nil)
        @numbergenerator.biggestSiteNumber = @numbergenerator.biggestSiteNumber + 1
         newlayername = type + @numbergenerator.biggestSiteNumber.to_s + "."
      elsif(input.to_s != "false")
        newlayername = input.to_s + "."
      else
        return
      end


      prompts = ["Select LOD"]
       list = ["lod1|lod2|lod3|lod123|lod12|lod23"]
       defaults = ["lod1"]
       lod = UI.inputbox prompts, defaults, list, "LOD Selektion"
       if(lod.to_s == false)
         newlayername = newlayername + "lod1"
       else
         newlayername = newlayername + lod[0].to_s
       end

        layer = model.layers.add newlayername
       if(selection != nil)
          selection.each{|entity|
          entity.layer= layer

         }
      end



  end

  def extractNewLayerName
    newlayername = ""
    model = Sketchup.active_model
    selection = model.selection
    selection.each{|entity|
      if(newlayername != "")
        return newlayername.upcase
      end
      layername = entity.layer.name.upcase
      #puts "selekionsobjekt hat layernamen " + layername
      if(@nametester.isbuildinginst(layername) or @nametester.isbridgeinst(layername) or @nametester.istunnelinst(layername))
        newlayername = extractinstname(entity.layer.name)
        puts "ist eine installation"
      elsif(@nametester.isbuildingpart(layername) or @nametester.istunnelpart(layername) or @nametester.isbridgepart(layername))
        newlayername = extractpartname(entity.layer.name)
        puts "ist ein part"
      elsif(@nametester.isbuilding(layername) or @nametester.isbridge(layername) or @nametester.istunnel(layername) )
        newlayername = extractsupername(entity.layer.name)
        puts "ist ein supertyp"
      end
    }
    return newlayername.upcase
  end



def extractpartname(layername)
   loop = 0
   newname = ""
    layername.each_line('.'){|substr|
         substr = substr.chomp('.')
          if(substr != nil)
            if(loop == 0)
              newname = substr
            elsif(loop == 1)
              newname = newname +"."+substr
            end
          end
          loop = loop +1
     }
     puts "returniere " + newname
     return newname
end

def extractinstname(layername)
   loop = 0
   doloop2 = false
   newname = ""
   layername = layername.upcase
    layername.each_line('.'){|substr|
         substr = substr.chomp('.')
          if(substr != nil)
            if(loop == 0)
              newname = substr
            elsif(loop == 1)
              if(@nametester.isbuildingpart(substr) or @nametester.istunnelpart(substr) or @nametester.isbridgepart(substr))
                  newname = newname +"."+substr
                  doloop2 = true
              else
                newname = newname +"."+substr
              end
            elsif(loop == 2 and doloop2)
               newname = newname +"."+substr
            end
          end
          loop = loop +1
     }
      puts "returniere " + newname
     return newname
end

def extractsupername(layername)
   loop = 0
   newname = ""
    layername.each_line('.'){|substr|
         substr = substr.chomp('.')
          if(substr != nil)
            if(loop == 0)
              newname = substr
            end
          end
          loop = loop +1
     }
      puts "returniere " + newname 
     return newname
end









end
